#!/bin/bash

FASTCHAT_ENV=fastchat_env
#FASTCHAT_PATH=$HOME/FastChat/fastchat/serve/

# https://stackoverflow.com/questions/61915607/commandnotfounderror-your-shell-has-not-been-properly-configured-to-use-conda
source ~/.bashrc 2>&1 >/dev/null
conda init bash 2>&1 >/dev/null

model_name=$1
num_gpus=$4
max_gpu_memory=$5GiB

conda activate $FASTCHAT_ENV

#cd $HOME # do we really need this? (I think not)

# note that it may have the following error: https://github.com/huggingface/diffusers/issues/736
#python3 -m fastchat.serve.huggingface_api --model lmsys/$1 --num-gpus $num_gpus --max-gpu-memory 8GiB --temperature $2 --save_file_name $3
if [ "$num_gpus" = "None" ] && [ "$max_gpu_memory" = "NoneGiB" ]; then
    python3 -m fastchat.serve.huggingface_api --model ${model_name} --temperature $2 --save_file_name $3
elif [ "$num_gpus" = "None" ]; then
    python3 -m fastchat.serve.huggingface_api --model ${model_name} --max-gpu-memory ${max_gpu_memory} --temperature $2 --save_file_name $3
elif [ "$max_gpu_memory" = "NoneGiB" ]; then
    python3 -m fastchat.serve.huggingface_api --model ${model_name} --num-gpus $4 --temperature $2 --save_file_name $3
else
    python3 -m fastchat.serve.huggingface_api --model ${model_name} --num-gpus $4 --max-gpu-memory ${max_gpu_memory} --temperature $2 --save_file_name $3
fi
